package dev.shadowsoffire.apotheosis.ench.table;

import net.minecraftforge.network.NetworkDirection;
import java.util.Optional;
import net.minecraft.client.gui.screens.Screen;
import dev.shadowsoffire.placebo.network.MessageHelper;
import net.minecraft.client.Minecraft;
import net.minecraftforge.network.NetworkEvent;
import java.util.function.Supplier;
import net.minecraft.network.FriendlyByteBuf;
import dev.shadowsoffire.placebo.network.MessageProvider;

public class StatsMessage
{
    protected final ApothEnchantmentMenu.TableStats stats;
    
    public StatsMessage(final ApothEnchantmentMenu.TableStats stats) {
        this.stats = stats;
    }
    
    public static class Provider implements MessageProvider<StatsMessage>
    {
        public Class<?> getMsgClass() {
            return StatsMessage.class;
        }
        
        public void write(final StatsMessage msg, final FriendlyByteBuf buf) {
            msg.stats.write(buf);
        }
        
        public StatsMessage read(final FriendlyByteBuf buf) {
            return new StatsMessage(ApothEnchantmentMenu.TableStats.read(buf));
        }
        
        public void handle(final StatsMessage msg, final Supplier<NetworkEvent.Context> ctx) {
            MessageHelper.handlePacket(() -> {
                final Screen patt1294$temp = Minecraft.m_91087_().f_91080_;
                if (patt1294$temp instanceof final ApothEnchantScreen es) {
                    es.menu.stats = msg.stats;
                }
            }, (Supplier)ctx);
        }
        
        public Optional<NetworkDirection> getNetworkDirection() {
            return Optional.of(NetworkDirection.PLAY_TO_CLIENT);
        }
    }
}
